#! /usr/bin/env python
#coding=utf-8

'''
by Lerry http://lerry.org
Start from 2011/07/27 22:49:51
Last edit at 2012/09/29
'''
import os
import posixpath
import urllib
import mimetypes
import email.utils
import shutil
import time
import thread
import sqlite3
import string
import struct
import xml.dom.minidom
import urllib
import os.path
import re
from xml.etree.ElementTree import ElementTree
from xml.etree.ElementTree import Element
from xml.etree.ElementTree import SubElement
from xml.etree.ElementTree import dump
from xml.etree.ElementTree import Comment
from xml.etree.ElementTree import tostring

sid_start=1
git_root_path = "https://raw.github.com/mash2k3/MashSports/master/Buzzy_Channels.xml"
tvlist = {"Buzzy_Channels.xml":"Entertainment",
          }

def WriteXmlFile(channelList,sid,name,genre,thumb,linkList):
    task = Element('Item')
    channelList.append(task)
    SubElement(task, 'sid').text = "%d"%sid
    SubElement(task, 'name').text = name
    SubElement(task, 'genre').text = genre
    SubElement(task, 'thumb').text = thumb
    for link in linkList:
        #print link[2]
        sublink = SubElement(task, 'link')
        sublink.text = link[2]
        #task.append(sublink)
    return channelList

def makeXmlList():
    ##Create xml structure
    taskXML = ElementTree()
    cList = Element('Channels')
    taskXML._setroot(cList)

    maincur.execute("select * from channellist")
    channels = maincur.fetchall()

    for r in channels:
        sid = r[1]
        name = r[2].encode()
        genre = r[3].encode()
        thumblink = r[4].encode()

        if thumblink.strip():
            thumb = "logo/%d.png"%sid
        else:
            thumb = "None"

        maincur.execute("select * from sublink where sid=%d"%sid)
        links = maincur.fetchall()
        #print links

        ##Call function
        WriteXmlFile(cList,sid,name,genre,thumb,links)
    ##Output xml file
    taskXML.write('TVList.xml','utf-8')

def cbk(a, b, c):
    if c > 0:
        per = 100.0 * a * b / c
        if per > 100:
            per = 100
            print '%.2f%%'%per

def download_remote_file(url):
    cmd = "wget -t 2 %s"%url
    os.system(cmd)

def download_icon(sid, iconUrl):
    print "sid=%d"%sid
    print iconUrl
    
    targetfile = os.path.basename(iconUrl)

    try:
        #urllib.urlretrieve(iconUrl ,targetfile ,cbk)
        download_remote_file(iconUrl)
    except:
        print iconUrl+" can not be downloaded"
        return

    if os.path.exists(targetfile)== False:
        print iconUrl+" download filed"
        return
        
    cmd = "convert -sample 120x80 %s"%targetfile+ " logo/%d.png"%sid
    os.system(cmd)
    os.system("rm -f %s"%targetfile)

def download_list(url):
    print 'Downloading %s'%url
    targetfile = os.path.basename(url)
    #urllib.urlretrieve(url ,targetfile ,cbk)
    download_remote_file(url)
    return targetfile

def check_link_presence(sid, url):
    maincur.execute("select * from sublink where sid=%d"%sid)
    links = maincur.fetchall()
    for link in links:
        if url == link[2]:
            return True
    return False

def playlist_parseXml(url, mode):
    global sid_start
    global maincon
    global maincur
    print url, mode

    cmd = "wget %s"%git_root_path
    os.system(cmd)

    #cmd = "cp %s"%url+" ./"
    #os.system(cmd)

    filename = os.path.basename(url)

    #filename = "newsk1.xml"
    print filename

    link = open(filename).read()
    link=link.replace('\r','').replace('\n','').replace('\t','').replace('&nbsp;','')
    match=re.compile('<title>(.+?)</title><link>(.+?)</link><thumbnail>(.+?)</thumbnail>').findall(link)
    for name,url,thumb in match:
        #print name, url, thumb
        if re.findall('http',thumb):
            thumbs=thumb

        tagNum = name.count("COLOR")
        if(tagNum > 0):
            titleMatch = re.compile('\](.+?)\[/COLOR\]').findall(name)
            if len(titleMatch) > 0:
                name = titleMatch[0]

        dumpString = re.findall('\[.*?\]',name)
        for dump in dumpString:
            name = name.replace(dump,'')

        name = name.strip()
        name = name.replace('\'', '')
        print name
        
        maincur.execute("select sid from channellist where title='%s'"%name)
        sidlist = maincur.fetchone()
        print sidlist
        sid = sid_start
        
        if sidlist != None:
            sid=sidlist[0]
            #print sid
            #maincur.execute("delete sublink from sublink where sid=%d"%sid)
            #sublinks = maincur.fetchall()            
        else:
            sid = sid_start
            maincur.execute('INSERT INTO channellist(sid, title, genre, thumbnail) VALUES(?, ?, ?, ?)',(sid, name, mode, thumb) )
            sid_start=sid_start+1
            if thumb.strip():
        	download_icon(sid, thumb)

        maincon.commit()
        matchlink = re.compile('<sublink>(.+?)</sublink>').findall(url)

        if len(matchlink)>0:
            for sublink in matchlink:
                if check_link_presence(sid, sublink)==False:
                    maincur.execute('INSERT INTO sublink(sid, sublink) VALUES(?, ?)',(sid, sublink) )
        else:
            if check_link_presence(sid, url)==False:
                maincur.execute('INSERT INTO sublink(sid, sublink) VALUES(?, ?)',(sid, url) )
        maincon.commit()

        

def parseSouceLinks():
    for key in tvlist:
        playlist_parseXml(key, tvlist[key])
        
    

def createdb():
    global maincon
    global maincur
    maincon = sqlite3.connect('LiveTVList.db3')
    maincur = maincon.cursor()
    
    maincur.execute('CREATE TABLE if not exists channellist(id INTEGER primary key autoincrement, sid INTEGER, title text, genre text, thumbnail text)')
    maincur.execute('CREATE TABLE if not exists sublink(id INTEGER primary key autoincrement, sid INTEGER, sublink text)')
    
    maincon.commit()
    
    #maincur.execute('INSERT INTO stblist(unique_id, barcode, mac, ipAddr, status, action) VALUES(?, ?, ?, ?, ?, ?)',(str_id, my_barcode, my_mac, my_ip, my_status, my_action) )
    #maincon.commit()



if __name__=='__main__':
    createdb()
    parseSouceLinks()
    makeXmlList()
    
    global maincon
    maincon.close()

